// $Id: features.cc,v 1.4 2008/11/25 22:56:06 xulin730 Exp $

#include <stdlib.h>
#include <iostream>
#include "tsplib.h"
using namespace std;

Stopwatch gSW;
const char* mypath;

int main( int argc, char *argv[] )
{
   
    const char* tourfile="TOUR_FILE";
    double oldTime=0.0;
    double newTime=0.0;
    bool domst=true;
    bool docluster=false;
    bool dols=false;
    bool dobc=false;
    bool doacf=false;

    string fullPath(argv[0]);
    size_t lastSlashPos=fullPath.find_last_of('/');
    string myownpath=fullPath.substr(0,lastSlashPos);

    if (lastSlashPos==-1){
		myownpath=".";
      }
    mypath=myownpath.c_str();

   if(argc < 2)
    {
      cerr << "Usage: "<<argv[0] <<" {  [-all] || [-mst] [-cluster] [-ls] [-bc] [-acf]} infile [outfile]" << endl;
      return 1;
    }
  int nextParam=1;
  if(strcmp(argv[nextParam],"-all")==0)
    {
       domst=true;
       docluster=true;
       dols=true;
       dobc=true;
       doacf=true;
       nextParam++;
      if(nextParam==argc)
	{
	  cerr << "Usage: "<<argv[0] <<"  {  [-all] || [-mst] [-cluster] [-ls] [-bc] [-acf]} infile [outfile]" << endl;
	  return 1;
	}
    }
  else {
    if(strcmp(argv[nextParam],"-mst")==0)
      {
	domst=true;
	nextParam++;
	if(nextParam==argc)
	  {
	    cerr << "Usage: "<<argv[0] <<"  {  [-all] || [-mst] [-cluster] [-ls] [-bc] [-acf]} infile [outfile]" << endl;
	    return 1;
	  }
      }
    if(strcmp(argv[nextParam],"-cluster")==0)
      {
	docluster=true;
	nextParam++;
	if(nextParam==argc)
	  {
	   cerr << "Usage: "<<argv[0] <<"  {  [-all] || [-mst] [-cluster] [-ls] [-bc] [-acf]} infile [outfile]" << endl;
	  }
      }

     if(strcmp(argv[nextParam],"-ls")==0)
      {
	dols=true;
	nextParam++;
	if(nextParam==argc)
	  {
	 cerr << "Usage: "<<argv[0] <<"  {  [-all] || [-mst] [-cluster] [-ls] [-bc] [-acf]} infile [outfile]" << endl;
	    return 1;
	  }
      }
   if(strcmp(argv[nextParam],"-bc")==0)
      {
	dobc=true;
	nextParam++;
	if(nextParam==argc)
	  {
	   cerr << "Usage: "<<argv[0] <<"  {  [-all] || [-mst] [-cluster] [-ls] [-bc] [-acf]} infile [outfile]" << endl;
	    return 1;
	  }
      }
    if(strcmp(argv[nextParam],"-acf")==0)
      {
	doacf=true;
	nextParam++;
	if(nextParam==argc)
	  {
	  cerr << "Usage: "<<argv[0] <<"  {  [-all] || [-mst] [-cluster] [-ls] [-bc] [-acf]} infile [outfile]" << endl;
	    return 1;
	  }
      }
}
    char* tspfilename = argv[nextParam++];
    
    char newfile[256];
    char mycmd[512];
    char tmpName[256];
    sprintf(newfile, "%s/", P_tmpdir);
    sprintf(tmpName, "XXXXXX");
    mkstemp(tmpName);
    strcat(newfile, tmpName);
    sprintf(mycmd, "cp %s %s", tspfilename, newfile);
    system(mycmd);
    TSPinstance *tsp =new TSPinstance(newfile);
    tsp->filename=newfile;
 
    gSW.Start();
// ============ output instance information ====================
    //   tsp->outputSypec();
// ============ computer distance matrix related features ======

     tsp-> comp_std(); 
     newTime=gSW.TotalLap();
     tsp->writeFeature("stdTime", newTime-oldTime);
     oldTime=newTime;

// ============ compute minimal spanning tree related features =
if (domst) {
     tsp->comp_mst();
     newTime=gSW.TotalLap();
     tsp->writeFeature("mstTime", newTime-oldTime);
     oldTime=newTime;

 
}
//    tsp->display_mst();
// ============ computer clustering related features ===========
if (docluster) { 
   tsp->cluster_distance();
    newTime=gSW.TotalLap();
     tsp->writeFeature("clusterTime", newTime-oldTime);
     oldTime=newTime;
}

// ============ computer lp probing features ====================
if (dols) {
    tsp->ls_prob(mypath);
 newTime=gSW.TotalLap();
     tsp->writeFeature("lpTime", newTime-oldTime);
     oldTime=newTime;
}
// ============= compute branch and bound probing features =====
if (dobc) {
   tsp->bc_prob(mypath);
    newTime=gSW.TotalLap();
     tsp->writeFeature("bcTime", newTime-oldTime);
     oldTime=newTime;
}
// =========== compute auto correlation features (ruggness)======
if (doacf) { 
   tsp->comp_acf();
     newTime=gSW.TotalLap();
     tsp->writeFeature("acfTime", newTime-oldTime);
     oldTime=newTime;
}

// == output instance features =================================== 
 if(argc > nextParam )
    {
      tsp->writeFeatNamesToFile(argv[nextParam]);
      tsp->writeFeaturesToFile(argv[nextParam]);
    }
  else
    {
      tsp->writeFeatNamesToFile(stdout);
      tsp->writeFeaturesToFile(stdout);
    }
// =========== clen everything up
    tsp->~TSPinstance(); 
//    cout << "End of program!" <<endl;

  // delete tsp;
    
    sprintf(mycmd, "rm -f %s/", P_tmpdir);
    strcat(mycmd, tmpName);
    strcat(mycmd, "*");
    system(mycmd);
  
    sprintf(mycmd, "rm -f %s/O", P_tmpdir);
    strcat(mycmd, tmpName);
    strcat(mycmd, "*");
    system(mycmd);
  //
    sprintf(mycmd, "rm -f ./");
    strcat(mycmd, tmpName);
    strcat(mycmd, "*");
    system(mycmd);
  
    sprintf(mycmd, "rm -f ./O");
    strcat(mycmd, tmpName);
    strcat(mycmd, "*");
    system(mycmd);
  
  return 0;
}